<!-- 服务编辑弹窗 -->
<template >
  <ele-modal
    :width="400"
    :visible="visible"
    :confirm-loading="loading"
    :title="'审批拒绝'"
    :body-style="{ paddingBottom: '8px' }"
    @update:visible="updateVisible"
    @ok="save"
  >
    <a-form
      ref="formRef"
      :model="form"
      :rules="rules"
      :wrapper-col="
        styleResponsive ? { md: 19, sm: 19, xs: 24 } : { flex: '1' }
      "
    >
        <a-textarea
          :rows="4"
          :maxlength="360"
          name="rejectReason"
          placeholder="请输入拒绝理由"
          v-model:value="form.rejectReason"
        />
    </a-form>
  </ele-modal>
</template>

<script lang="ts" setup>
  import { ref, reactive, watch } from 'vue';
  import { message } from 'ant-design-vue/es';
  import type { FormInstance, Rule } from 'ant-design-vue/es/form';
  import { storeToRefs } from 'pinia';
  import { useThemeStore } from '@/store/modules/theme';
  import useFormData from '@/utils/use-form-data';
  import { reject } from '@/api/withdraw';
  import type {AuditRejectParam } from '@/api/withdraw/model';

  // 是否开启响应式布局
  const themeStore = useThemeStore();
  const { styleResponsive } = storeToRefs(themeStore);

  const emit = defineEmits<{
    (e: 'done'): void;
    (e: 'update:visible', visible: boolean): void;
  }>();

  const props = defineProps<{
    // 弹窗是否打开
    visible: boolean;
    // 修改回显的数据
    data?: AuditRejectParam | null;
  }>();

  //
  const formRef = ref<FormInstance | null>(null);

  // 提交状态
  const loading = ref(false);

  // 表单数据
  const { form, resetFields, assignFields } = useFormData<AuditRejectParam>({
    id: undefined,
    rejectReason: ''
  });

  // 表单验证规则
  const rules = reactive<Record<string, Rule[]>>({
    rejectReason: [
      {
        required: true,
        message: '请输入拒绝理由',
        type: 'string',
        trigger: 'blur'
      }
    ]
  });

  /* 保存编辑 */
  const save = () => {
    if (!formRef.value) {
      return;
    }
    formRef.value.validate()
      .then(() => {
        loading.value = true
        console.log("提交审核数据：",form)
        reject(form)
          .then((msg) => {
            loading.value = false
            message.success("审核拒绝成功！");
            updateVisible(false);
            emit('done');
          })
          .catch((e) => {
            loading.value = false;
            message.error(e);
          });
      })
      .catch(() => {});
  };

  const updateVisible = (value: boolean) => {
    emit('update:visible', value);
  };

  watch(
    () => props.visible,
    (visible) => {
      if (visible) {
        if (props.data) {
          assignFields(props.data);
        }
      } else {
        resetFields();
        formRef.value?.clearValidate();
      }
    }
  );
</script>
